

# CreateImageRecipe
<a name="API_CreateImageRecipe"></a>

Creates a new image recipe. Image recipes define how images are configured, tested, and assessed.

## Request Syntax
<a name="API_CreateImageRecipe_RequestSyntax"></a>

```
PUT /CreateImageRecipe HTTP/1.1
Content-type: application/json

{
   "additionalInstanceConfiguration": { 
      "systemsManagerAgent": { 
         "uninstallAfterBuild": boolean
      },
      "userDataOverride": "string"
   },
   "amiTags": { 
      "string" : "string" 
   },
   "blockDeviceMappings": [ 
      { 
         "deviceName": "string",
         "ebs": { 
            "deleteOnTermination": boolean,
            "encrypted": boolean,
            "iops": number,
            "kmsKeyId": "string",
            "snapshotId": "string",
            "throughput": number,
            "volumeSize": number,
            "volumeType": "string"
         },
         "noDevice": "string",
         "virtualName": "string"
      }
   ],
   "clientToken": "string",
   "components": [ 
      { 
         "componentArn": "string",
         "parameters": [ 
            { 
               "name": "string",
               "value": [ "string" ]
            }
         ]
      }
   ],
   "description": "string",
   "name": "string",
   "parentImage": "string",
   "semanticVersion": "string",
   "tags": { 
      "string" : "string" 
   },
   "workingDirectory": "string"
}
```

## URI Request Parameters
<a name="API_CreateImageRecipe_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateImageRecipe_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalInstanceConfiguration](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-additionalInstanceConfiguration"></a>
Specify additional settings and launch scripts for your build instances.  
Type: [AdditionalInstanceConfiguration](API_AdditionalInstanceConfiguration.md) object  
Required: No

 ** [amiTags](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-amiTags"></a>
Tags that are applied to the AMI that Image Builder creates during the Build phase prior to image distribution.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[a-zA-Z0-9\s_.:/=+\-@]*$`   
Value Length Constraints: Maximum length of 256.  
Required: No

 ** [blockDeviceMappings](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-blockDeviceMappings"></a>
The block device mappings of the image recipe.  
Type: Array of [InstanceBlockDeviceMapping](API_InstanceBlockDeviceMapping.md) objects  
Required: No

 ** [clientToken](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-clientToken"></a>
Unique, case-sensitive identifier you provide to ensure idempotency of the request. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html) in the *Amazon EC2 API Reference*.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

 ** [components](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-components"></a>
The components included in the image recipe.  
Type: Array of [ComponentConfiguration](API_ComponentConfiguration.md) objects  
Array Members: Minimum number of 1 item.  
Required: No

 ** [description](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-description"></a>
The description of the image recipe.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: No

 ** [name](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-name"></a>
The name of the image recipe.  
Type: String  
Pattern: `^[-_A-Za-z-0-9][-_A-Za-z0-9 ]{1,126}[-_A-Za-z-0-9]$`   
Required: Yes

 ** [parentImage](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-parentImage"></a>
The base image for customizations specified in the image recipe. You can specify the parent image using one of the following options:  
+ AMI ID
+ Image Builder image Amazon Resource Name (ARN)
+  AWS Systems Manager (SSM) Parameter Store Parameter, prefixed by `ssm:`, followed by the parameter name or ARN.
+  AWS Marketplace product ID
If you enter an AMI ID or an SSM parameter that contains the AMI ID, you must have access to the AMI, and the AMI must be in the source Region.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: Yes

 ** [semanticVersion](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-semanticVersion"></a>
The semantic version of the image recipe. This version follows the semantic version syntax.  
The semantic version has four nodes: <major>.<minor>.<patch>/<build>. You can assign values for the first three, and can filter on all of them.  
 **Assignment:** For the first three nodes you can assign any positive integer value, including zero, with an upper limit of 2^30-1, or 1073741823 for each node. Image Builder automatically assigns the build number to the fourth node.  
 **Patterns:** You can use any numeric pattern that adheres to the assignment requirements for the nodes that you can assign. For example, you might choose a software version pattern, such as 1.0.0, or a date, such as 2021.01.01.
Type: String  
Pattern: `^(?:[0-9]+|x)\.(?:[0-9]+|x)\.(?:[0-9]+|x)$`   
Required: Yes

 ** [tags](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-tags"></a>
The tags of the image recipe.  
Type: String to string map  
Map Entries: Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[a-zA-Z0-9\s_.:/=+\-@]*$`   
Value Length Constraints: Maximum length of 256.  
Required: No

 ** [workingDirectory](#API_CreateImageRecipe_RequestSyntax) **   <a name="imagebuilder-CreateImageRecipe-request-workingDirectory"></a>
The working directory used during build and test workflows.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: No

## Response Syntax
<a name="API_CreateImageRecipe_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "clientToken": "string",
   "imageRecipeArn": "string",
   "latestVersionReferences": { 
      "latestMajorVersionArn": "string",
      "latestMinorVersionArn": "string",
      "latestPatchVersionArn": "string",
      "latestVersionArn": "string"
   },
   "requestId": "string"
}
```

## Response Elements
<a name="API_CreateImageRecipe_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [clientToken](#API_CreateImageRecipe_ResponseSyntax) **   <a name="imagebuilder-CreateImageRecipe-response-clientToken"></a>
The client token that uniquely identifies the request.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.

 ** [imageRecipeArn](#API_CreateImageRecipe_ResponseSyntax) **   <a name="imagebuilder-CreateImageRecipe-response-imageRecipeArn"></a>
The Amazon Resource Name (ARN) of the image recipe that was created by this request.  
Type: String  
Pattern: `^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):image-recipe/[a-z0-9-_]+/(?:[0-9]+|x)\.(?:[0-9]+|x)\.(?:[0-9]+|x)$` 

 ** [latestVersionReferences](#API_CreateImageRecipe_ResponseSyntax) **   <a name="imagebuilder-CreateImageRecipe-response-latestVersionReferences"></a>
The resource ARNs with different wildcard variations of semantic versioning.  
Type: [LatestVersionReferences](API_LatestVersionReferences.md) object

 ** [requestId](#API_CreateImageRecipe_ResponseSyntax) **   <a name="imagebuilder-CreateImageRecipe-response-requestId"></a>
The request ID that uniquely identifies this request.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.

## Errors
<a name="API_CreateImageRecipe_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** CallRateLimitExceededException **   
You have exceeded the permitted request rate for the specific operation.  
HTTP Status Code: 429

 ** ClientException **   
These errors are usually caused by a client action, such as using an action or resource on behalf of a user that doesn't have permissions to use the action or resource, or specifying an invalid resource identifier.  
HTTP Status Code: 400

 ** ForbiddenException **   
You are not authorized to perform the requested operation.  
HTTP Status Code: 403

 ** IdempotentParameterMismatchException **   
You have specified a client token for an operation using parameter values that differ from a previous request that used the same client token.  
HTTP Status Code: 400

 ** InvalidRequestException **   
You have requested an action that that the service doesn't support.  
HTTP Status Code: 400

 ** InvalidVersionNumberException **   
Your version number is out of bounds or does not follow the required syntax.  
HTTP Status Code: 400

 ** ResourceAlreadyExistsException **   
The resource that you are trying to create already exists.  
HTTP Status Code: 400

 ** ResourceInUseException **   
The resource that you are trying to operate on is currently in use. Review the message details and retry later.  
HTTP Status Code: 400

 ** ServiceException **   
This exception is thrown when the service encounters an unrecoverable exception.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
You have exceeded the number of permitted resources or operations for this service. For service quotas, see [EC2 Image Builder endpoints and quotas](https://docs.aws.amazon.com/general/latest/gr/imagebuilder.html#limits_imagebuilder).  
HTTP Status Code: 402

 ** ServiceUnavailableException **   
The service is unable to process your request at this time.  
HTTP Status Code: 503

## See Also
<a name="API_CreateImageRecipe_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/imagebuilder-2019-12-02/CreateImageRecipe) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/imagebuilder-2019-12-02/CreateImageRecipe) 